//Phillip A. Conophy
//"Among the Crystal Reefs"
//4-21-97

//***Control Points***
//#declare LeftEye = <0, 0, 0>
//#declare RightEye = <0, 0, 0>
//#declare LeftFin = <0, 0, 0>
//#declare RightFin = <0, 0, 0>
//#declare Link = <0, 0, 0>
//#declare Tail = <0, 0, 0>

//***Textures***
//#declare BodyTex =
//#declare FinTex =
//#declare EyeTex =
//#declare EngineTex =

#declare Fish =
merge {
	difference {
		merge {
			sphere {	//MainBody
				<0, 0, 0>
				1
				scale <100, 50, 35>
                texture { BodyTex }
			}
			sphere {	//CenterRidge
				<0, 0, 0>
				1
				scale <100, 60, 5>
                texture { FinTex }
			}
			sphere {	//LeftRidge
				<0, 0, 0>
				1
				scale <100, 52, 5>
				rotate < -33, 0, 0 >
                texture { FinTex }
			}
			sphere {	//RightRidge
				<0, 0, 0>
				1
				scale <100, 52, 5>
				rotate < 33, 0, 0 >
                texture { FinTex }
			}
			difference {	//DorsalFin
				cylinder {
					<0, 0, -1>
					<0, 0, 1>
					100
				}
				cylinder {
					<-92, 35, -2>
					<-92, 35, 2>
					58
				}
				cylinder {
					<96, 17, -2>
					<96, 17, 2>
					29
				}
				box {
					<-110, -110, -2>
					<110, 0, 2>
				}
                texture { FinTex }
			}
			merge {	//RearLink
				box {
					<90, -5, -10>
					<70, 5, 10>
				}
				cylinder {
					<110, -5, 0>
					<110, 5, 0>
					10
				}
                texture { BodyTex }
			}
			difference {	//LeftStabalizer
				cylinder {
					<0, 0, 0>,
					<0, 1, 0>,
					1
					scale <10, 2, 30>
					rotate <-70, -4, 38>
					translate < 63.242, -59.752, -22.705 >
				}
				cylinder {
					<0, 0, 0>
					<0, 1, 0>
					1
					scale <8, 6, 30>
					rotate < -69.642, 0.97265, 24.531 >
					translate < 72.835, -59.087, -21.979 >
				}
                texture { FinTex }
			}
			difference {	//RightStabalizer
				cylinder {
					<0, 0, 0>,
					<0, 1, 0>,
					1
					scale <10, 2, 30>
					rotate <-110, -4, 38>
					translate < 63.009, -59.066, 23.883 >
				}
				cylinder {
					<0, 0, 0>
					<0, 1, 0>
					1
					scale <8, 6, 30>
					rotate < -108.48, -8.7507, 24.372 >
					translate < 71.572, -57.47, 28.021 >
				}
                texture { FinTex }
			}
			merge {	//LeftFin
				sphere {
					< 0, 0, 0 >
					7
                    texture { BodyTex }
				}
				difference {
					cylinder {
						< 0, 0, 0 >,
						< 0, 1, 0 >,
						1
						scale < 60, 2, 16 >
				        rotate < -90, 0, 0 >
					    translate < 60, 0, -2 >
		            }
			        cylinder {
						< 0, 0, 0 >,
						< 0, 1, 0 >,
						1
						scale < 32, 4, 18 >
						rotate < -90, 0, 0 >
						translate < 92, 0, -1 >
					}
                    texture { FinTex }
		        }
				rotate LeftFin
				translate <-17, -17, -34>
			}
			merge {	//RightFin
				sphere {
					< 0, 0, 0 >
					7
                    texture { BodyTex }
				}
				difference {
					cylinder {
						< 0, 0, 0 >,
						< 0, 1, 0 >,
						1
						scale < 60, 2, 16 >
				        rotate < -90, 0, 0 >
					    translate < 60, 0, 2 >
		            }
			        cylinder {
						< 0, 0, 0 >,
						< 0, 1, 0 >,
						1
						scale < 32, 4, 18 >
						rotate < -90, 0, 0 >
						translate < 92, 0, 3 >
					}
                    texture { FinTex }
		        }
				rotate RightFin
				translate <-17, -17, 34>
			}
            merge { //LeftEye
    			difference {
    				sphere {
    					<0, 0, 0>
    	   				12
    	   			}
    				sphere {
    					<0, 0, -12>
    					5
    				}
                    texture { BodyTex }
    			}
                sphere {
                    <0, 0, 0>
                    1
                    hollow
                    texture { EyeTex }
                    scale<5, 5, 5>
                    translate <0, 0, -12>
                }
 				rotate LeftEye
   				translate <-75, 20, -20>
            }
            merge { //RightEye
    			difference {	//RightEye
    	   			sphere {
    					<0, 0, 0>
    					12
    				}
    				sphere {
    					<0, 0, 12>
    					5
    				}
                    texture { BodyTex }
    			}
                sphere {
                    <0, 0, 0>
                    1
                    hollow
                    texture { EyeTex }
                    scale<5, 5, 5>
                    translate <0, 0, 12>
                }
 				rotate RightEye
   				translate <-75, 20, 20>
            }
		}
		difference {	//MouthCutter
			cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 16, 35, 12 >
	            rotate < 0, 0, 90 >
	            translate < -70, -16, 0 >
	        }
			box {
				< -125, -40, -16 >
				< -63, -17, 16 >
			}
            texture { BodyTex }
	    }
		difference {	//Gill1
			cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 80, 20 >
	            rotate < -90, 0, 0 >
	            translate < -55, 0, 40 >
	        }
	        cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 100, 20 >
				rotate < -90, 0, 0 >
				translate < -57, 0, 50 >
	        }
            texture { BodyTex }
	    }
		difference {	//Gill2
			cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 80, 20 >
	            rotate < -90, 0, 0 >
	            translate < -47, 0, 40 >
	        }
	        cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 100, 20 >
				rotate < -90, 0, 0 >
				translate < -49, 0, 50 >
	        }
            texture { BodyTex }
	    }
		difference {	//Gill3
			cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 80, 20 >
	            rotate < -90, 0, 0 >
	            translate < -39, 0, 40 >
	        }
	        cylinder {
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 7, 100, 20 >
				rotate < -90, 0, 0 >
				translate < -41, 0, 50 >
	        }
            texture { BodyTex }
	    }
	}
	merge {	//Tail
		merge {  //TailLink
			cylinder {	//TailBar
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 2.5, 30, 10 >
				translate < 12.5, -15, 0 >
                texture { BodyTex }
	        }
            cylinder {	//TailBottom
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 10, 10, 10 >
	            translate < 0, -15, 0 >
                texture { BodyTex }
	        }
	        cylinder {	//TailTop
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 10, 10, 10 >
				translate < 0, 5, 0 >
                texture { BodyTex }
	        }
	        cone {	//ForeEngine
				< 0, 0, 0 >,
				1,
				< 0, 1, 0 >,
				0
				scale < 15, 55, 10 >
				rotate < 0, 0, -90 >
				translate < 13, 0, 0 >
                texture { BodyTex }
			}
            difference {    //RearEngine
   		        cone {
   					< 0, 0, 0 >,
   					1,
   					< 0, 1, 0 >,
   					0
   					scale < 15, 25, 10 >
   					rotate < 0, 0, 90 >
   					translate < 71, 0, 0 >
   				}
       		    sphere {	//EngineEmission
       				< 0, 0, 0 >,
       				1
       				scale < 8.4, 11, 6 >
       				translate < 71, 0, 0 >
       			}
                texture { BodyTex }
            }
            difference {    //TailFin
  		        cylinder {	//TailFin
   					< 0, 0, 0 >,
   					< 0, 1, 0 >,
   					1
   					scale < 60, 2, 85 >
   					rotate < -90, 0, 0 >
   					translate < 70, 0, 1 >
                    texture { FinTex }
   				}
       		    box {	//CenterTailCut
       				< 0, 0, 0 >,
       				< 1, 1, 1 >
       				scale < 65, 30, 10 >
       				translate < 70, -15, -5 >
                    texture { FinTex }
       			}
       			cylinder {	//TopTailCut
       				< 0, 0, 0 >,
       				< 0, 1, 0 >,
       				1
       				scale < 32, 10, 20 >
       				rotate < -90, 0, 0 >
       				translate < 102, 15, 5 >
                    texture { FinTex }
       			}
       			cylinder {	//BottomTailCut
       				< 0, 0, 0 >,
       				< 0, 1, 0 >,
       				1
       				scale < 32, 10, 20 >
       				rotate < -90, 0, 0 >
       				translate < 102, -15, 5 >
                    texture { FinTex }
       			}
            }
            difference {    //EngineGlow
                sphere {    //EngineGlow
   				    < 0, 0, 0 >,
   				    1
                }
                box {
                    <-1.5, -1.5, -1.5>
                    <-0.05, 1.5, 1.5>
                }
                hollow
                texture { EngineTex }
//   				scale < 8.4, 11, 6 >
			    scale < 75, 11, 6 >
                translate < 71, 0, 0 >
            }
            texture { BodyTex }
   			rotate Tail
   			translate <25, 0, 0>
        }
		merge {	//Link
			cylinder {	//LinkForBottom
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 10, 10, 10 >
				translate < 0, -15, 0 >
		    }
			cylinder {	//LinkForTop
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 10, 10, 10 >
				translate < 0, 5, 0 >
		    }
			cylinder {	//LinkRear
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 10, 10, 10 >
				translate < 25, -5, 0 >
			}
			cylinder {	//LinkBar
				< 0, 0, 0 >,
				< 0, 1, 0 >,
				1
				scale < 2.5, 30, 10 >
				translate < 12.5, -15, 0 >
			}
            texture { BodyTex }
		}
		rotate Link
		translate <110, 0, 0>
	}
}
